class PitchLayer extends Layer {
    // La courbe Haut: Pitch 
  PitchLayer(PApplet parent) {
    super(parent);
  }

  void setup() {
    //    textFont(maFonte);
    smooth();
    noStroke();
  }

  void draw() {
    if (IndexPitch < LignesPitch.length) {
      LignePitch = float(split(LignesPitch[IndexPitch], "   "));
      if (Float.isNaN(LignePitch[0])) {
        IndexPitch = IndexPitch + 1;
      }
      // println("temps = " + temps + "  LignePitch[0] = " + LignePitch[0]);
      if ((temps > LignePitch[0]) && ! Pause) {
        xApresPitch = FacteurX * (width) * LignePitch[0] / DureeFichier;      
        if (((xAvantPitch % width) > (xApresPitch % width)) && (IndexPitch < LignesPitch.length - 10) ) EffaceEcran();
        if (Float.isNaN(LignePitch[1])) {
          PitchActuel = PitchMini;
          IndexPitch = IndexPitch + 1;
          Trace = false;
          xAvantPitch = xApresPitch; 
          // println("NaN IndexPitch = " + IndexPitch);
        }
        else {
          PitchActuel = LignePitch[1];
          yApresPitch = YPitch(PitchActuel) ;
          if (Trace && ((xAvantPitch % width) > 0) && FlagLigneHaut) {
            // stroke(255); // Ligne blanche
            stroke(0, 255, 0); // Ligne verte
            strokeWeight(EpaisseurCourbe);
            line(xAvantPitch % width, yAvantPitch, xApresPitch % width, yApresPitch);
          }
          xAvantPitch = xApresPitch;    
          yAvantPitch = yApresPitch;
          Trace = true;
          IndexPitch = IndexPitch + 1;
        }
      }
    } 
    else Fin = true;

  // Texte courbe Haut pitch 
  NombreDeChild2 = kidkid1Data[CoucheHaut].getChildCount();
  if (IndexXMLHaut < NombreDeChild2) {
    kid1 = kidkid1Data[CoucheHaut].getChild(IndexXMLHaut);
    // n = kid1.getInt("n"); 
    xmin = kid1.getFloat("xmin"); 
    xmax = kid1.getFloat("xmax"); 
    Content1 = kid1.getContent();
    // println("Child(" + IndexXMLHaut +  "): n = " + n + " xmin = " + xmin + " xmax = " + xmax + " " + Content1);
    if (Content1 == null) IndexXMLHaut = IndexXMLHaut + 1;
    else if (Content1.equals("_") == true) IndexXMLHaut = IndexXMLHaut + 1;//Elimination des caracteres _ qui separe les segments
    else {
      // if ((temps > xmin) && ! Pause) {
      // if ((temps > xmax) && ! Pause) {
      if ((temps > (xmin + xmax) / 2) && (! Pause)) {
        if (FlagTexteHaut) {
          fill(0, 255, 0); // Texte vert
          // fill(255); // Texte blanc
          // textFont(maFonte, LignePitch[1] / 10);
          textFont(maFonte, PitchActuel / 5);  // Plantage avec Font autre que Helvetica si Size = NaN
          // yApresPitch = YPitch(LignePitch[1]) ;
          // text(Content1, xApresPitch % width, yApresPitch - 20);
          text(Content1, xApresPitch % width, YPitch(PitchActuel) - 20);
        }
        IndexXMLHaut = IndexXMLHaut + 1;
        colFixe = col;
      }
    }
  }


    if (frameCount % AdjustBlurTextSpectrum == 0) filter(BLUR, 0.572);  // > 0.575
  }
}

